>From 9a44b4d71cc30c66057ae2da7d508d70ffc6d412 Mon Sep 17 00:00:00 2001
From: Ade Lee <alee@redhat.com>
Date: Thu, 8 Aug 2013 10:53:39 -0400
Subject: [PATCH] initial changes to configure tps through pkispawn

---
 .pydevproject                                      |    5 +-
 base/ca/shared/conf/CS.cfg.in                      |    2 +-
 .../certsrv/system/ConfigurationRequest.java       |  119 +-
 .../cms/servlet/csadmin/ConfigurationUtils.java    |  142 +-
 .../cms/servlet/csadmin/SystemConfigService.java   |  819 ++++---
 base/kra/shared/conf/CS.cfg.in                     |    2 +-
 base/ocsp/shared/conf/CS.cfg.in                    |    2 +-
 base/server/config/pkislots.cfg                    |    5 +-
 base/server/etc/default.cfg                        |    8 +
 .../python/pki/server/deployment/pkihelper.py      |   18 +-
 .../python/pki/server/deployment/pkiparser.py      |   19 +-
 base/tks/shared/conf/CS.cfg.in                     |    2 +-
 base/tps/shared/conf/CS.cfg.in                     | 2490 ++++++++++----------
 base/tps/shared/conf/db.ldif                       |   81 +-
 base/tps/shared/conf/index.ldif                    |  261 +-
 base/tps/shared/conf/schema.ldif                   |  537 +----
 base/tps/shared/conf/vlv.ldif                      |   51 +
 base/tps/shared/conf/vlvtasks.ldif                 |   28 +
 18 files changed, 2242 insertions(+), 2349 deletions(-)
 create mode 100644 base/tps/shared/conf/vlv.ldif
 create mode 100644 base/tps/shared/conf/vlvtasks.ldif

diff --git a/.pydevproject b/.pydevproject
index f77c43e1099b1020624dc7fa9c986904ede94681..4a8d2616b64ba9f4a243247c2ee2ac28fc6461c2 100644
--- a/.pydevproject
+++ b/.pydevproject
@@ -3,11 +3,8 @@
 <pydev_property name="org.python.pydev.PYTHON_PROJECT_INTERPRETER">Default</pydev_property>
 <pydev_property name="org.python.pydev.PYTHON_PROJECT_VERSION">python 2.7</pydev_property>
 <pydev_pathproperty name="org.python.pydev.PROJECT_SOURCE_PATH">
-<path>/pki/base/server/src</path>
-<path>/pki/base/server/src/engine</path>
-<path>/pki/base/server/src/scriptlets</path>
-<path>/pki/base/server/python/pki/server</path>
 <path>/pki/base/common/python/pki</path>
+<path>/pki/base/server/python/pki/server</path>
 <path>/pki/base/kra/functional</path>
 </pydev_pathproperty>
 </pydev_project>
diff --git a/base/ca/shared/conf/CS.cfg.in b/base/ca/shared/conf/CS.cfg.in
index d028453108f7693f5e562cf5468fa68c3334e660..837ec9a27acc3260ce9915cb4924a6c5a90638f9 100644
--- a/base/ca/shared/conf/CS.cfg.in
+++ b/base/ca/shared/conf/CS.cfg.in
@@ -51,7 +51,7 @@ service.clientauth_securePort=[PKI_EE_SECURE_CLIENT_AUTH_PORT]
 service.unsecurePort=[PKI_UNSECURE_PORT]
 service.instanceID=[PKI_INSTANCE_NAME]
 preop.admin.name=Certificate System Administrator
-preop.admin.group=Certificate Manager Agents
+preop.admin.group=Certificate Manager Agents, Administrators
 preop.admincert.profile=caAdminCert
 preop.pin=[PKI_RANDOM_NUMBER]
 ca.cert.list=signing,ocsp_signing,sslserver,subsystem,audit_signing
diff --git a/base/common/src/com/netscape/certsrv/system/ConfigurationRequest.java b/base/common/src/com/netscape/certsrv/system/ConfigurationRequest.java
index 170e1c031f042f6ae483c53d2382672b2d151c28..23021a5731e57885380368e3075a99e9abb296f6 100644
--- a/base/common/src/com/netscape/certsrv/system/ConfigurationRequest.java
+++ b/base/common/src/com/netscape/certsrv/system/ConfigurationRequest.java
@@ -74,6 +74,17 @@ public class ConfigurationRequest {
     private static final String STEP_TWO = "stepTwo";
     private static final String GENERATE_SERVER_CERT = "generateServerCert";
 
+    // TPS specific parameters
+    private static final String AUTHDB_BASEDN = "authdbBaseDN";
+    private static final String AUTHDB_HOST = "authdbHost";
+    private static final String AUTHDB_PORT = "authdbPort";
+    private static final String AUTHDB_SECURE_CONN = "authdbSecureConn";
+    private static final String CA_URI = "caUri";
+    private static final String TKS_URI = "tksUri";
+    private static final String KRA_URI = "kraUri";
+    private static final String ENABLE_SERVER_SIDE_KEYGEN = "enableServerSideKeygen";
+
+
     //defaults
     public static final String TOKEN_DEFAULT = "Internal Key Storage Token";
     public static final String NEW_DOMAIN = "newdomain";
@@ -208,6 +219,30 @@ public class ConfigurationRequest {
     @XmlElement(defaultValue = "true")
     protected String generateServerCert;
 
+    @XmlElement
+    protected String authdbBaseDN;
+
+    @XmlElement
+    protected String authdbHost;
+
+    @XmlElement
+    protected String authdbPort;
+
+    @XmlElement(defaultValue="false")
+    protected String authdbSecureConn;
+
+    @XmlElement
+    protected String caUri;
+
+    @XmlElement
+    protected String tksUri;
+
+    @XmlElement
+    protected String kraUri;
+
+    @XmlElement(defaultValue="false")
+    protected String enableServerSideKeyGen;
+
     public ConfigurationRequest() {
         // required for JAXB
     }
@@ -255,9 +290,16 @@ public class ConfigurationRequest {
         importAdminCert = form.getFirst(IMPORT_ADMIN_CERT);
         stepTwo = form.getFirst(STEP_TWO);
         generateServerCert = form.getFirst(GENERATE_SERVER_CERT);
+        authdbBaseDN = form.getFirst(AUTHDB_BASEDN);
+        authdbHost = form.getFirst(AUTHDB_HOST);
+        authdbPort = form.getFirst(AUTHDB_PORT);
+        authdbSecureConn = form.getFirst(AUTHDB_SECURE_CONN);
+        caUri = form.getFirst(CA_URI);
+        tksUri = form.getFirst(TKS_URI);
+        kraUri = form.getFirst(KRA_URI);
+        enableServerSideKeyGen = form.getFirst(ENABLE_SERVER_SIDE_KEYGEN);
     }
 
-
     public String getSubsystemName() {
         return subsystemName;
     }
@@ -772,6 +814,70 @@ public class ConfigurationRequest {
         this.generateServerCert = generateServerCert;
     }
 
+    public String getAuthdbBaseDN() {
+        return authdbBaseDN;
+    }
+
+    public void setAuthdbBaseDN(String authdbBaseDN) {
+        this.authdbBaseDN = authdbBaseDN;
+    }
+
+    public String getAuthdbHost() {
+        return authdbHost;
+    }
+
+    public void setAuthdbHost(String authdbHost) {
+        this.authdbHost = authdbHost;
+    }
+
+    public String getAuthdbPort() {
+        return authdbPort;
+    }
+
+    public void setAuthdbPort(String authdbPort) {
+        this.authdbPort = authdbPort;
+    }
+
+    public String getAuthdbSecureConn() {
+        return authdbSecureConn;
+    }
+
+    public void setAuthdbSecureConn(String authdbSecureConn) {
+        this.authdbSecureConn = authdbSecureConn;
+    }
+
+    public String getCaUri() {
+        return caUri;
+    }
+
+    public void setCaUri(String caUri) {
+        this.caUri = caUri;
+    }
+
+    public String getTksUri() {
+        return tksUri;
+    }
+
+    public void setTksUri(String tksUri) {
+        this.tksUri = tksUri;
+    }
+
+    public String getKraUri() {
+        return kraUri;
+    }
+
+    public void setKraUri(String kraUri) {
+        this.kraUri = kraUri;
+    }
+
+    public String getEnableServerSideKeyGen() {
+        return enableServerSideKeyGen;
+    }
+
+    public void setEnableServerSideKeyGen(String enableServerSideKeyGen) {
+        this.enableServerSideKeyGen = enableServerSideKeyGen;
+    }
+
     @Override
     public String toString() {
         return "ConfigurationRequest [pin=XXXX" +
@@ -815,6 +921,15 @@ public class ConfigurationRequest {
                ", adminCert=" + adminCert +
                ", importAdminCert=" + importAdminCert +
                ", generateServerCert=" + generateServerCert +
-               ", stepTwo=" + stepTwo + "]";
+               ", stepTwo=" + stepTwo +
+               ", authdbBaseDN=" + authdbBaseDN +
+               ", authdbHost=" + authdbHost +
+               ", authdbPort=" + authdbPort +
+               ", authdbSecureConn=" + authdbSecureConn +
+               ", caUri=" + caUri +
+               ", kraUri=" + kraUri +
+               ", tksUri=" + tksUri +
+               ", enableServerSideKeyGen=" + enableServerSideKeyGen +
+               "]";
     }
 }
diff --git a/base/common/src/com/netscape/cms/servlet/csadmin/ConfigurationUtils.java b/base/common/src/com/netscape/cms/servlet/csadmin/ConfigurationUtils.java
index 893a95a891e98187eda7a3b0a48980ed1b12be0e..1ca0476a6cd5196e49b88ba1af989477909cdca0 100644
--- a/base/common/src/com/netscape/cms/servlet/csadmin/ConfigurationUtils.java
+++ b/base/common/src/com/netscape/cms/servlet/csadmin/ConfigurationUtils.java
@@ -29,6 +29,7 @@ import java.io.IOException;
 import java.io.PrintStream;
 import java.math.BigInteger;
 import java.net.ConnectException;
+import java.net.URI;
 import java.net.URISyntaxException;
 import java.net.URLEncoder;
 import java.security.DigestException;
@@ -3095,7 +3096,7 @@ public class ConfigurationUtils {
             EBaseException {
         IUGSubsystem system = (IUGSubsystem) (CMS.getSubsystem(IUGSubsystem.ID));
         IConfigStore config = CMS.getConfigStore();
-        String groupName = config.getString("preop.admin.group", "Certificate Manager Agents");
+        String groupNames = config.getString("preop.admin.group", "Certificate Manager Agents,Administrators");
 
         IUser user = null;
 
@@ -3119,16 +3120,13 @@ public class ConfigurationUtils {
         }
 
         IGroup group = null;
-
-        group = system.getGroupFromName(groupName);
-        if (!group.isMember(uid)) {
-            group.addMemberName(uid);
-            system.modifyGroup(group);
-        }
-        group = system.getGroupFromName("Administrators");
-        if (!group.isMember(uid)) {
-            group.addMemberName(uid);
-            system.modifyGroup(group);
+        for (String groupName : groupNames.split(",")) {
+            groupName = groupName.trim();
+            group = system.getGroupFromName(groupName);
+            if (!group.isMember(uid)) {
+                group.addMemberName(uid);
+                system.modifyGroup(group);
+            }
         }
 
         String select = config.getString("securitydomain.select", "");
@@ -3536,6 +3534,39 @@ public class ConfigurationUtils {
         return null;
     }
 
+    public static String getTransportCert(URI secdomainURI, URI kraUri)
+            throws IOException, SAXException, ParserConfigurationException {
+        CMS.debug("getTransportCert() start");
+        String sessionId = CMS.getConfigSDSessionId();
+
+        String content = "&xmlOutput=true" +
+                "&sessionID=" + sessionId +
+                "&auth_hostname=" + secdomainURI.getHost() +
+                "&auth_port=" + secdomainURI.getPort();
+
+        String c = getHttpResponse(
+                kraUri.getHost(),
+                kraUri.getPort(),
+                true,
+                "/kra/admin/kra/getTransportCert",
+                content, null, null);
+
+        if (c != null) {
+            ByteArrayInputStream bis =
+                    new ByteArrayInputStream(c.getBytes());
+            XMLObject parser = new XMLObject(bis);
+            String status = parser.getValue("Status");
+            if (status.equals(SUCCESS)) {
+                String s = parser.getValue("TransportCert");
+                return s;
+            } else {
+                return null;
+            }
+        }
+        return null;
+    }
+
+
     public static void importCACertToOCSP() throws IOException, EBaseException, CertificateEncodingException {
         IConfigStore config = CMS.getConfigStore();
 
@@ -3648,6 +3679,95 @@ public class ConfigurationUtils {
         removeOldDBUsers(certs[0].getSubjectDN().toString());
     }
 
+    public static void registerUser(URI secdomainURI, URI targetURI, String targetType) throws Exception {
+        IConfigStore cs = CMS.getConfigStore();
+        String csType = cs.getString("cs.type");
+        String uid = csType.toUpperCase() + "-" + cs.getString("machineName", "")
+                + "-" + cs.getString("service.securePort", "");
+        String sessionId = CMS.getConfigSDSessionId();
+        String subsystemName = cs.getString("preop.subsystem.name");
+
+        String content = "uid=" + uid +
+                "&xmlOutput=true" +
+                "&sessionID=" + sessionId +
+                "&auth_hostname=" + secdomainURI.getHost() +
+                "&auth_port=" + secdomainURI.getPort() +
+                "&certificate=" + URLEncoder.encode(getSubsystemCert(), "UTF-8") +
+                "&name=" + subsystemName;
+
+        String targetURL = "/" + targetType + "/admin/" + targetType + "/registerUser";
+
+        String response = getHttpResponse(
+                targetURI.getHost(),
+                targetURI.getPort(),
+                true,
+                targetURL,
+                content, null, null);
+
+        if (response == null || response.equals("")) {
+            CMS.debug("registerUser: response is empty or null.");
+            throw new IOException("The server " + targetURI + "is not available");
+        } else {
+            ByteArrayInputStream bis = new ByteArrayInputStream(response.getBytes());
+            XMLObject parser = new XMLObject(bis);
+
+            String status = parser.getValue("Status");
+            CMS.debug("registerUser: status=" + status);
+
+            if (status.equals(SUCCESS)) {
+                CMS.debug("registerUser: Successfully added user " + uid + "to " + targetURI);
+            } else if (status.equals(AUTH_FAILURE)) {
+                throw new EAuthException(AUTH_FAILURE);
+            } else {
+                String error = parser.getValue("Error");
+                throw new IOException(error);
+            }
+        }
+    }
+
+    public static void exportTransportCert(URI secdomainURI, URI targetURI, String transportCert) throws Exception {
+        IConfigStore cs = CMS.getConfigStore();
+        String name = "transportCert-" + cs.getString("machineName", "")
+                + "-" + cs.getString("service.securePort", "");
+        String sessionId = CMS.getConfigSDSessionId();
+
+        String content = "name=" + name +
+                "&xmlOutput=true" +
+                "&sessionID=" + sessionId +
+                "&auth_hostname=" + secdomainURI.getHost() +
+                "&auth_port=" + secdomainURI.getPort() +
+                "&certificate=" + URLEncoder.encode(transportCert, "UTF-8");
+
+        String targetURL = "/tks/admin/tks/importTransportCert";
+
+        String response = getHttpResponse(
+                targetURI.getHost(),
+                targetURI.getPort(),
+                true,
+                targetURL,
+                content, null, null);
+
+        if (response == null || response.equals("")) {
+            CMS.debug("exportTransportCert: response is empty or null.");
+            throw new IOException("The server " + targetURI + "is not available");
+        } else {
+            ByteArrayInputStream bis = new ByteArrayInputStream(response.getBytes());
+            XMLObject parser = new XMLObject(bis);
+
+            String status = parser.getValue("Status");
+            CMS.debug("exportTransportCert: status=" + status);
+
+            if (status.equals(SUCCESS)) {
+                CMS.debug("exportTransportCert: Successfully added transport cert to " + targetURI);
+            } else if (status.equals(AUTH_FAILURE)) {
+                throw new EAuthException(AUTH_FAILURE);
+            } else {
+                String error = parser.getValue("Error");
+                throw new IOException(error);
+            }
+        }
+    }
+
     public static void removeOldDBUsers(String subjectDN) throws EBaseException, LDAPException {
         IUGSubsystem system = (IUGSubsystem) (CMS.getSubsystem(IUGSubsystem.ID));
         IConfigStore cs = CMS.getConfigStore();
